# WolfPack

## Control all your tame wolves at the same time!

### NEW: Local multiplayer support. Support for all tame creatures.

You've tamed them, fed them, bred them and love them. They love you too, but they're always looking for attention and getting in the way. And you have to pet each of them to get them to do what you want. 

What you need is a little obedience training. With WolfPack, one keystroke will get all your tame wolves (or other creatures) to follow or stay at the same time. 

## What's new with 0.9.6

- New support for multi-player on local servers (see _Multiplayer_ below for limitations)
- Character rotator now displays on center of screen (faster response)

## What's new with 0.9.4

- Supports all tame creatures including those from PopVillages and other mods
- Configure a list of creatures to call by name, (e.g., Wolf, Boar, Lox)
- Configure groups of creatures to call with a wildcard (e.g., Human*, Greydwarf*, *)
- Configure a single key Follow/Stay toggle, or separate Follow & Stay keys
- Cycle through creatures to call using keyboard or mouse wheel
- Filter creatures to call by number of "stars"

## Configuration

### General

- **DetectionRange**: The maximum distance from a player that creatures will be affected by a Follow or Stay command. Default value is 50. Can be set from 1 to 150.

- **TrainableCreatures**: a comma delimited list of creature names that will respond to Follow and Stay. Only tamed creatures will be affected. Default value is "wolf".
   - Example 1: [ wolf, boar, lox ]
    
    Calls either wolf, boar, or lox, depending on which was the current selection (see _CharacterSelectionKey_ 
    below). You may append an asterisk (*) as the _last_ character in a creature name to include all characters
    who's name begins with the letters before the asterisk.

   - Example 2: [ Human*,Human Guard ]

   The first item would call all Human creatures (from PopVillages) whose name begins with 
   "Human", including Human Commoners and Human Guards. The second item would only call Human Guards. **NOTE**: you 
   need to provide the actual _token_ name of the creature, not the display name. (see _LogCreatureNames_ below)

   - Example 3: [ * ]
   Calls all tamed creatures.

- **PackBehaviorShortcut**: The keystroke to toggle between Follow and Stay for the currently selected creature. If you set _UseTwoKeys_ to True (see below), this key will only issue the Follow command. Default is LeftAlt+T

- **UseTwoKeys**: If set to True will use a separate keystroke for the Stay command as configured in _AlternateStayShortcut_ (see below). Default is False

- **AlternateStayShortcut**: The keystrokes to call creatures to Stay. Only used if _UseTwoKeys_ (above) is set to True. Default is LeftAlt+Y

- **CreatureSelectorShortcut**: The keystroke to rotate through the list of _TrainableCreatures_ (above). Pressing this key repeatedly will cycle through the configured list. If _UseMouseWheel_ (see below) is set to True, holding this key down while spinning the mouse wheel will cycle through the configured list. The current selected creature will appear in the message area in the center of the screen (or top left under the hot bar as configured by _Notifications_ below). Default is LeftAlt+U

- **MinimumCreatureLevel**: The \'lowest' level of creature (in \'stars') affected by Follow and Stay. **NOTE**: This setting will be applied to all _TrainableCreatures_. Default is 0. Can be set from 0 to 2

- **UseMouseWheel**: If set to True, the mouse wheel is used to cycle through the _TrainableCreatures_ list to set the current creature. Hold down the _CreatureSelectorShortcut_ key while spinning the mouse wheel. If you don't have a mouse with a wheel or use another input device that makes this difficult, set to False. Default is True

- **Notifications**: The character rotation text in the Center is much more responsive to changes and is now the default value, however, you can set this value to TopLeft if you prefer the notifications in that location.

### Audio

- **UseSound**: If set to True, will use the sound configured in _PackCallSound_ (below) whenever creatures are called to follow.

- **PackCallSound**: The audio clip played when creatures are called to Follow. Default is Whistle.wav. WolfPack is distributed with three audio clips; Whistle.wav, Horn1.wav, and Horn2.wav.

Whistle is a sharp finger whistle, Horn1 is a traditional hunting horn, and Horn2 is a deeper battle horn. These clips are located in the same folder as WolfPack.dll (...\BepInEx\plugins\Neobotics-WolfPack)

**NOTE**: You can put your own audio clips in this folder, and set _PackCallSound_ to your file name. Be advised, however, this is 'at your own risk'. WolfPack has only been tested with the three included files, which are 16-bit uncompressed PCM WAV files sampled at 44100.

### Utility

- **MouseWheelLatency**: Controls the mouse wheel spin behavior so 'big' spins don't 'overshoot' the next creature in the configured list. The default is 3, which should be sufficient for most users. Increase this value if the wheel spin is too sensitive and you find yourself \'skipping' over creatures in the list. Decrease this value if you find the wheel's response is too 'sluggish'. Can be set from 0 to 10. 

- **LogCreatureNames**: If set to True, will log all 'found' creatures called with Follow and Stay. This may be useful to identify the actual creature name as opposed to the display name when configuring the _TrainableCreatures_ list. The \'real' creature name may be different from what is displayed in the game. For instance, the "Greydwarf Brute" is actually "Greydwarf_Elite". Do not include the "$enemy_" prefix (e.g., $enemy_Wolf) in the _TrainableCharacters_ list. A good source for the \'real' creature names can be found at: https://valheimgamer.com/kb/cheats-and-console-commands/

## Multiplayer

- Multiplayer is new with v 0.9.6 and is considered "alpha". Please report any issues, but be patient.
- Multiplayer is currently only supported on local servers (dedicated servers are on the backlog).
- Audio is not currently multiplayer enabled. You will hear your own call, but not that of others (also on the backlog)
- Wolves are finicky. It may take a few seconds for them to respond, especially on your first call.

### Known issues

- Wolves are loyal. Generally, they will remain with whomever summons them until they are released. Occasionally, another player may call a previously summoned wolf, which may respond to the new caller.
- Wolves have an independent streak. Once in a while some of them may not respond to one player's call, after being released by another player. Usually this can be corrected with the second player releasing and re-calling them. Also make sure they're within your summoning range because they have a habit of wandering off.

## Compatibility Issues & Defects

- WolfPack is a new mod. While every effort goes into ensuring it works as described, there's no way to test every possible game scenario, especially with other mods or multiplayer.

- If you find a compatibility issue you can post it on NexusMods at: https://www.nexusmods.com/valheim/mods/1549?tab=posts. It's likely a compatibility issue if WolfPack works with the other mod disabled. Be sure to include the mod name and version you think may be incompatible.

- If you have a bug please report it on NexusMods at https://www.nexusmods.com/valheim/mods/1549?tab=bugs. If you do post a bug report, please make sure to include the following:
   - Your version of Valheim
   - Your version of WolfPack
   - What you were doing, or attempting to do when it happened
   - If it's repeatable - i.e., can you duplicate it?
   - The exact behavior you observed (or didn't observe)
   - If possible, a capture of the log file with errors (WolfPack errors always begin with "WolfPack ...")

## Notes

WolfPack does not modify any 'pet' interactions with creatures. In other words, you can't use WolfPack to pet individual creatures, such as Lox to Follow or Stay (like Wolves) without some other mod. 

You can, however, ride at the front of a herd of charging Lox!

Your comments and feedback are always welcome. Please feel free to post on NexusMods or send a personal note.